' Simple XTRA Weather
' By }-=Loki=-{
' lokiwashere@yahoo.co.nz
' DONT FORGET TO EDIT THE XTRAWEATHER.INI FILE TO CHOOSE YOUR CITY

SchemaName = "C:\Program Files\Samurize\Scripts\XtraWeather.ini"
WeatherPNGPath = "C:\Program Files\Samurize\Skins\XtraWeather\"

' **********  This just fixes up the E.S.T time for NZ (+ 12 hours) 
Private Function AddOneDayToName(dayname)
	AddOneDayToName = dayname
	if AddOneDayToName = "Sunday" then
		AddOneDayToName = "Monday"
	Else		
		If AddOneDayToName = "Saturday" then AddOneDayToName = "Sunday"
		If AddOneDayToName = "Friday" then AddOneDayToName = "Saturday"
		If AddOneDayToName = "Thursday" then AddOneDayToName = "Friday"
		If AddOneDayToName = "Wednesday" then AddOneDayToName = "Thursday"
		If AddOneDayToName = "Tuesday" then AddOneDayToName = "Wednesday"
		If AddOneDayToName = "Monday" then AddOneDayToName = "Tuesday"
	
	End If
End Function

' **********  Gets the Weather.TTF Character to display the sun, etc depending on the WID
Private Function GetSymbolChar(icon)
        dim icons
        GetSymbolChar = A
        icons = array("",  "B","B","D","D","A","B","A","B","B","B",  "B","B","A","A","A","A","D","B","","",  "","","","","","S","","R","R","R",  "","Q","","R","D","I","E","E","","A",  "A","A","R")
'       icons = array("",  "","","","","","","","","","",            "","","","","","","","","","",          "","","","","","","","S","","F",   "","I","","Q","","","D","D","","",     "","", "")     

        GetSymbolChar = icons(icon)
End Function

Private Function GetSymbolCharFromText(picname)
	if picname = "snow" then GetSymbolCharFromText = "P"
	if picname = "thunder" then GetSymbolCharFromText = "E"
	if picname = "hail" then GetSymbolCharFromText = "C"
	if picname = "rain" then GetSymbolCharFromText = "B"
	if picname = "showers" then GetSymbolCharFromText = "A"
	if picname = "fewshowers" then GetSymbolCharFromText = "A"
	if picname = "partcloudy" then GetSymbolCharFromText = "R"
	if picname = "fine" then GetSymbolCharFromText = "Q"
	if picname = "cloud" then GetSymbolCharFromText = "S"
	if picname = "cloudy" then GetSymbolCharFromText = "S"
	if picname = "drizzle" then GetSymbolCharFromText = "A"
	if picname = "wind" then GetSymbolCharFromText = "E"
End Function

Private Function GetPNGFilenameFromText(picname)
	GetPNGFilenameFromText = WeatherPNGPath + "na.png"
	if picname = "snow" then GetPNGFilenameFromText = WeatherPNGPath + "weather_snow_icon.png"
	if picname = "thunder" then GetPNGFilenameFromText = WeatherPNGPath + "weather_thunder_icon.png"
	if picname = "hail" then GetPNGFilenameFromText = WeatherPNGPath + "weather_hail.png"
	if picname = "rain" then GetPNGFilenameFromText = WeatherPNGPath + "weather_rain_icon.png"
	if picname = "showers" then GetPNGFilenameFromText = WeatherPNGPath + "weather_few_showers.png"

	if picname = "fewshowers" then GetPNGFilenameFromText = WeatherPNGPath + "weather_few_showers.png"
	if picname = "partcloudy" then GetPNGFilenameFromText = WeatherPNGPath + "weather_scattered_clouds.png"

	if picname = "fine" then GetPNGFilenameFromText = WeatherPNGPath + "weather_sun_icon.png"
	if picname = "cloud" then GetPNGFilenameFromText = WeatherPNGPath + "weather_cloud_icon.png"
	if picname = "cloudy" then GetPNGFilenameFromText = WeatherPNGPath + "weather_cloud_icon.png"
	if picname = "drizzle" then GetPNGFilenameFromText = WeatherPNGPath + "weather_rain_icon.png"
	if picname = "wind" then GetPNGFilenameFromText = WeatherPNGPath + "weather_wind.png"
End Function


' ****************************************************************** Usable functions
Function GetWeather
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	GetWeather  = SimpleHTTP.DownloadAndParse(SchemaName)
	if GetWeather = -1 then 
	  GetWeather = "ERROR"
	else
	  GetWeather = "Downloaded"
	end if
	set SimpleHTTP = Nothing 
End Function

Function City
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	City = SimpleHTTP.RetrievedValue(SchemaName, "City", "?", 360)
	set SimpleHTTP = Nothing 
End Function


Function WeatherDate
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	WeatherDate = SimpleHTTP.RetrievedValue(SchemaName, "WeatherDate", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function FullDayName
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	FullDayName = SimpleHTTP.RetrievedValue(SchemaName, "FullDayName", "?", 360)
	set SimpleHTTP = Nothing 

	if FullDayName = "Sun" then FullDayName = "Sunday"
	If FullDayName = "Mon" then FullDayName = "Monday"
	If FullDayName = "Tue" then FullDayName = "Tuesday"
	If FullDayName = "Wed" then FullDayName = "Wednesday"
	If FullDayName = "Thu" then FullDayName = "Thursday"
	If FullDayName = "Fri" then FullDayName = "Friday"
	If FullDayName = "Sat" then FullDayName = "Saturday"
End Function

Function HighTemperature
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	HighTemperature = SimpleHTTP.RetrievedValue(SchemaName, "HighTemperature", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function LowTemperature
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	LowTemperature = SimpleHTTP.RetrievedValue(SchemaName, "LowTemperature", "?", 360)
	set SimpleHTTP = Nothing 
End Function


Function Temperature
	Temperature = LowTemperature & "-" & HighTemperature
End Function

Function WindDirection
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	WindDirection = SimpleHTTP.RetrievedValue(SchemaName, "WindDirection", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function WindStrength
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	WindStrength = SimpleHTTP.RetrievedValue(SchemaName, "WindStrength", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function Sunrise
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Sunrise = SimpleHTTP.RetrievedValue(SchemaName, "Sunrise", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function Sunset
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Sunset = SimpleHTTP.RetrievedValue(SchemaName, "Sunset", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function Symbol
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "picname", "?", 360)
	set SimpleHTTP = Nothing 
        Symbol = GetSymbolCharFromText(picname)
End Function

Function Sky
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "picname", "?", 360)
	set SimpleHTTP = Nothing 
	Sky = ""
	if picname = "snow" then Sky = "snow"
	if picname = "thunder" then Sky = "Thunder"
	if picname = "hail" then Sky = "Hail"
	if picname = "rain" then Sky = "rain"
	if picname = "showers" then Sky = "Showers"
	if picname = "fewshowers" then Sky = "Few Showers"
	if picname = "partcloudy" then Sky = "Partly Cloudy"
	if picname = "fine" then Sky = "Fine"
	if picname = "cloudy" then Sky = "Cloudy"
	if picname = "drizzle" then Sky = "Drizzle"
	if picname = "wind" then Sky = "Windy"
End Function

Function WeatherPNG
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "picname", "?", 360)
	set SimpleHTTP = Nothing 
        WeatherPNG = GetPNGFilenameFromText(picname)
End Function


' ************************* FORECAST DAYS
Function Forecast1_Day
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Forecast1_Day = SimpleHTTP.RetrievedValue(SchemaName, "Forecast1_Day", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function Forecast2_Day
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Forecast2_Day = SimpleHTTP.RetrievedValue(SchemaName, "Forecast2_Day", "?", 360)
	set SimpleHTTP = Nothing 
End Function

' ************************* FORECAST HIGHS
Function Forecast1_High
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Forecast1_High = SimpleHTTP.RetrievedValue(SchemaName, "Forecast1_High", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function Forecast2_High
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Forecast2_High = SimpleHTTP.RetrievedValue(SchemaName, "Forecast2_High", "?", 360)
	set SimpleHTTP = Nothing 
End Function

' ************************* FORECAST LOWS
Function Forecast1_Low
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Forecast1_Low = SimpleHTTP.RetrievedValue(SchemaName, "Forecast1_Low", "?", 360)
	set SimpleHTTP = Nothing 
End Function

Function Forecast2_low
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	Forecast2_Low = SimpleHTTP.RetrievedValue(SchemaName, "Forecast2_Low", "?", 360)
	set SimpleHTTP = Nothing 
End Function

' ************************* FORECAST SYMBOLS
Function Forecast1_Symbol
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "Forecast1_Symbol", "?", 360)
	set SimpleHTTP = Nothing 
        Forecast1_Symbol = GetSymbolCharFromText(picname)
End Function

Function Forecast2_Symbol
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "Forecast2_Symbol", "?", 360)
	set SimpleHTTP = Nothing 
        Forecast2_Symbol = GetSymbolCharFromText(picname)
End Function

' ************************* FORECAST TEMPERATURES (COMBINATION)
Function Forecast1_Temperature
        Forecast1_Temperature = Forecast1_Low & "-" & Forecast1_High
End Function

Function Forecast2_Temperature
        Forecast2_Temperature = Forecast2_Low & "-" & Forecast2_High
End Function

Function Forecast1_Sky
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "Forecast1_Symbol", "?", 360)
	set SimpleHTTP = Nothing 
	Forecast1_Sky = ""
	if picname = "snow" then Forecast1_Sky = "snow"
	if picname = "thunder" then Forecast1_Sky = "Thunder"
	if picname = "hail" then Forecast1_Sky = "Hail"
	if picname = "rain" then Forecast1_Sky = "rain"
	if picname = "showers" then Forecast1_Sky = "Showers"
	if picname = "fewshowers" then Forecast1_Sky = "Few Showers"
	if picname = "partcloudy" then Forecast1_Sky = "Partly Cloudy"
	if picname = "fine" then Forecast1_Sky = "Fine"
	if picname = "cloudy" then Forecast1_Sky = "Cloudy"
	if picname = "drizzle" then Forecast1_Sky = "Drizzle"
End Function

Function Forecast2_Sky
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "Forecast2_Symbol", "?", 360)
	set SimpleHTTP = Nothing 
	Forecast2_Sky = ""
	if picname = "snow" then Forecast2_Sky = "snow"
	if picname = "thunder" then Forecast2_Sky = "Thunder"
	if picname = "hail" then Forecast2_Sky = "Hail"
	if picname = "rain" then Forecast2_Sky = "rain"
	if picname = "showers" then Forecast2_Sky = "Showers"
	if picname = "fewshowers" then Forecast2_Sky = "Few Showers"
	if picname = "partcloudy" then Forecast2_Sky = "Partly Cloudy"
	if picname = "fine" then Forecast2_Sky = "Fine"
	if picname = "cloudy" then Forecast2_Sky = "Cloudy"
	if picname = "drizzle" then Forecast2_Sky = "Drizzle"
End Function

Function Forecast1_WeatherPNG
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "Forecast1_Symbol", "?", 360)
	set SimpleHTTP = Nothing 
        Forecast1_WeatherPNG = GetPNGFilenameFromText(picname)
End Function

Function Forecast2_WeatherPNG
	Dim SimpleHTTP
	Set SimpleHTTP = CreateObject("LokiControls.SimpleHTTPDownloaderAndParser")
	picname = SimpleHTTP.RetrievedValue(SchemaName, "Forecast2_Symbol", "?", 360)
	set SimpleHTTP = Nothing 
        Forecast2_WeatherPNG = GetPNGFilenameFromText(picname)
End Function

